From 23497dc6be5af13cfbcb54b1e41c4c3282fe3f67 Mon Sep 17 00:00:00 2001
From: Devyani Kota <divs.passion.18@gmail.com>
Date: Nov 06 2015 21:02:44 +0000
Subject: [PATCH 236/1001] Merge #54 `Fixed issue #53: Added clickable links for subscribed hubs`


---

diff --git a/hubs/widgets/subscriptions.py b/hubs/widgets/subscriptions.py
index 36e830d..db23691 100644
--- a/hubs/widgets/subscriptions.py
+++ b/hubs/widgets/subscriptions.py
@@ -1,4 +1,4 @@
-#from hubs.hinting import hint, prefixed as _
+# from hubs.hinting import hint, prefixed as _
 from hubs.widgets.base import argument
 from hubs.widgets.chrome import panel
 
@@ -8,13 +8,14 @@ import hubs.models
 
 from fedmsg.meta.base import BaseConglomerator as BC
 
+import flask
 import jinja2
 
 chrome = panel('Hubs', key='associations')
 template = jinja2.Template("""
 {% if associations %}
     {% if memberships %}
-        <p><strong>Belongs to: </strong>{{memberships_text}}</p>
+        <p><strong>Belongs to: </strong> {{memberships_text}}</p>
     {% endif %}
     <hr/>
     {% if subscriptions %}
@@ -37,16 +38,26 @@ def data(session, widget, username):
     ownerships = [u.name for u in user.ownerships]
     memberships = [u.name for u in user.memberships]
     subscriptions = [u.name for u in user.subscriptions]
+    subscriptions_list = manage_subscriptions(subscriptions)
+    memberships_list = manage_subscriptions(memberships)
     return dict(
         associations=memberships + ownerships,
         ownerships=ownerships,
         memberships=memberships,
         subscriptions=subscriptions,
         ownerships_text=BC.list_to_series(ownerships),
-        memberships_text=BC.list_to_series(memberships),
-        subscriptions_text=BC.list_to_series(subscriptions),
+        memberships_text=BC.list_to_series(memberships_list),
+        subscriptions_text=BC.list_to_series(subscriptions_list),
     )
 
 
+# function hyperlinks the hubs in the subscription widget
+def manage_subscriptions(items):
+    for index, item in enumerate(items[0:3]):
+        link = '<a href="{link}">{item}</a>'.format(link=flask.url_for(
+            'hub', name=item), item=item)
+        yield link
+
+
 def should_invalidate(message, session, widget):
     raise NotImplementedError()

